import json
import math
import random

# have Spiders test.json in the same dir as this script
# usage: python3 filter-spider-test.py
# writes randomly picked sub sample of 10 % per database to:
# <same location>/sub_sampled_spider_test_set.json

f = open('test.json')
data = json.load(f)
f.close()

dbids = []

# get list of db_ids
for nl2sql in data:
  if not nl2sql['db_id'] in dbids:
    dbids.append(nl2sql['db_id'])

subsampleSizes = []
counts = []
groups = []

# group by db_ids and collect subsample size of 10 % (rounded up to nearest int)
for dbid in dbids:
  counter = 0
  group = []
  for nl2sql in data:
    if nl2sql['db_id'] == dbid:
      counter = counter + 1
      group.append(nl2sql)
  subsampleSizes.append(math.ceil(counter * 0.1))
  counts.append(counter)
  groups.append(group)

pickedSamples = []
pickedLogging = []

# for each group, pick sampleSize many samples
for i in range(len(groups)):
  group = groups[i]
  j = 0
  pickedIds = []
  pickedGroup = []

  while j < subsampleSizes[i]:
    k = random.randint(0, counts[i] - 1)

    if k in pickedIds:
      continue

    pickedIds.append(k)
    pickedSamples.append(group[k])
    pickedGroup.append(group[k])

    j = j + 1;

  pickedLogging.append({
    "pickedIds" : pickedIds,
    "pickedGroup" : pickedGroup,
    "count" : counts[i],
    "subsampleSize": subsampleSizes[i]
  })

jsonOutFile = open("sub_sampled_spider_test_set.json", "w")
json.dump(pickedSamples, fp=jsonOutFile, indent=4)

# Comment this in to print chosen samples grouped to stdout
# print(json.dumps(pickedLogging, indent=4))

print("Picked x samples: ", len(pickedSamples), "From y Databases: ", len(groups))

